
#include "constable.h"
#include "generic.h"
#include <stdlib.h>

struct medusa_attribute_s *execute_get_last_attr( void );
char *execute_get_last_data( void );

/* generic_set_subject - *cinfo ukazuje do stromu
 */
int generic_set_subject( struct object_s *o, u_int32_t *cinfo, void *user )
{ 
  struct tree_s *t,*p;
  int a,inh;
//printf("ZZZ: aaaaaaaaaaaaaaaaaaaaaaaaa cinfo=%p stack=%p\n",cinfo,&t);
	if( (t=(struct tree_s *)(*cinfo))==NULL )
	{
		// nemozem lebo ak je neplatne, musi ostat neplatne
		// t=(struct tree_s*)user;
		// *cinfo=(u_int32_t)t;
		return(-1);
	}
//printf("ZZZ: cccccccccccccccc %p\n",t);
//printf("ZZZ: ccccccccccccccc2 %p\n",t->type);
printf("ZZZ: riesim generic_set_subject pre %s\n",t->type->name);
//fflush(stdout);
	inh=0;
	p=t;
#ifdef USE_ALT
	for(;t!=NULL;t=t->alt)
	{
#endif
//printf("ZZZ: dddddddddddddddd\n");
		for(a=0;a<NR_ACCESS_TYPES;a++)
		{	object_add_vs(o,a,t->vs[a]);
			object_add_vs(o,a,t->recursive_vs[a]);
		}
		object_add_event(o,&(t->event[0]));
		object_add_event(o,&(t->recursive_event[0]));
		if( t->child!=NULL || t->reg!=NULL )
			inh=1;
#ifdef USE_ALT
	}
#endif
//printf("ZZZ: eeeeeeeeeeeeeeee inh=%d class uzla '%s' class objektu '%s' event '%s'\n",inh,((struct event_type_s*)(p->type->user))->object->m.name,o->class->m.name, ((struct event_type_s*)(p->type->user))->m.name );
	if( inh && p->type->user!=NULL && ((struct event_type_s*)(p->type->user))->object==o->class )
		object_add_event(o,((struct event_type_s*)(p->type->user))->mask);
//printf("ZZZ: ffffffffffffffff\n");
	return(0);
}

int generic_hierarchy_handler(struct event_handler_s *h, struct event_context_s *c )
{ u_int32_t *cinfo;
  struct tree_s *t;
  char *n;
 
  vs_t vse[MAX_VS_BITS/32];

	cinfo= (u_int32_t *)(c->subject.data + ((struct g_event_handler_s*)h)->cinfo_offset);

	if( (t=(struct tree_s *)(*cinfo))==NULL )
	{	if( (((struct g_event_handler_s*)h)->flags & GFL_FROM_OBJECT)
		    && c->subject.class == c->object.class )
			t= (struct tree_s *)(*((u_int32_t *)(c->object.data + ((struct g_event_handler_s*)h)->cinfo_offset)));
		if( t==NULL )
			t=((struct g_event_handler_s*)h)->root;
		*cinfo=(u_int32_t)t;
	}
//printf("ZZZ: riesim generic_hierarchy_handler pre %s\n",t->type->name);

	((struct g_event_handler_s*)h)->subhandler->handler(((struct g_event_handler_s*)h)->subhandler,c);
	if( (execute_get_last_attr()->type & 0x0f) != MED_TYPE_STRING )
		n="";
	else	n=execute_get_last_data();
printf("ZZZ: %s/ hladam podla \"%s\" -\"%s\"-> \"",t->type->name,t->name,n);

	if( (t=find_one(t,n))==NULL )
	{	c->result=RESULT_DENY;
		return(-1);
	}
printf("%s\"\n",t->name);
//{ int ino;
//  struct medusa_attribute_s *a;
//   a=get_attribute(c->subject.class,"dev");
//   if( a )
//   { object_get_val(&(c->subject),a,&ino,sizeof(ino));
//     printf("0x%x:",ino);
//   }
//   a=get_attribute(c->subject.class,"ino");
//   if( a )
//   { object_get_val(&(c->subject),a,&ino,sizeof(ino));
//     printf("%d",ino);
//   }
//   printf("\n");
//}
	if( (((struct g_event_handler_s*)h)->flags & GFL_USE_VSE) )
	{	object_get_vs(vse,AT_ENTER,&(c->subject));

		if( vs_test(t->vs[AT_MEMBER],vse)
		     || vs_test(t->recursive_vs[AT_MEMBER],vse)
			 )
			*cinfo=(u_int32_t)t;
		else
		{	c->result=RESULT_DENY;
printf("ZZZ: nevnaram sa, lebo nemam ENTER!\n");
			return(0);
		}
	}
	else	*cinfo=(u_int32_t)t;

	object_do_sethandler(&(c->subject));
	c->result=RESULT_OK;
	return(0);
}

int generic_get_vs( vs_t *vs, int n, struct object_s *o, u_int32_t *cinfo )
{ struct tree_s *t;

	if( (t=(struct tree_s *)(*cinfo))==NULL )
	{	object_do_sethandler(o);
		if( (t=(struct tree_s *)(*cinfo))==NULL )
			return(-1);
	}
printf("ZZZ: riesim generic_get_vs pre %s\n",t->type->name);
	vs_add( t->vs[n] , vs );
	vs_add( t->recursive_vs[n] , vs );
	return(0);
}


int generic_init( char *name, struct event_handler_s *subhandler, struct event_type_s *event, struct class_s *class, int flags )
{ struct tree_type_s *type;
  struct g_event_handler_s *eh;
  int x;
	if( event!=NULL )
		class=event->op[0];
	if( (event!=NULL && ((event->m.actbit&0xc000)==0x4000))
		|| (x=class_alloc_subject_cinfo(class))<0 )
		x=class_alloc_object_cinfo(class);
	if( x<0 )
	{	init_error("Can't alloc cinfo for %s",name);
		return(-1);
	}
  	if( (type=malloc(sizeof(struct tree_type_s)+sizeof(name)+1))==NULL )
	{	init_error(Out_of_memory);
		return(-1);
	}
  	if( (eh=malloc(sizeof(struct g_event_handler_s)))==NULL )
	{	init_error(Out_of_memory);
		free(type);
		return(-1);
	}
	type->name= (char*)(type+1);
	strcpy(type->name,name);
	type->size= sizeof(struct tree_s);
	type->obj_class= class;	/* subject of access */
	type->cinfo_offset=x;
	type->user= (void*)(event);
	type->flags=flags;
	type->init=NULL;
	type->child_type=type;

	if( (eh->root=register_tree_type(type))==NULL )
	{	init_error("Can't register tree type %s",name);
		free(eh);
		free(type);
		return(-1);
	}

	if( class_add_sethandler(class,generic_set_subject,x,eh->root)<0 )
	{
		return(init_error("Can't add sethandler for %s/",name));
	}

	if( class_add_getvs(class,generic_get_vs,x)<0 )
	{
		return(init_error("Can't register getvs for %s/",name));
	}
	
	if( subhandler && event )
	{
		eh->h.op_name[0]=':';
		strncpy(eh->h.op_name+1,type->name,MEDUSA_OPNAME_MAX-1);
		eh->h.handler=generic_hierarchy_handler;
		eh->h.local_vars=NULL;
		eh->subhandler=subhandler;
		eh->cinfo_offset=x;
		eh->flags=flags;
printf("ZZZ: generic_init: registrujem event_handler\n");
		if( register_event_handler((struct event_handler_s*)eh,event,ALL_OBJ,ALL_OBJ)<0 )
		{
			return(init_error("Can't register event handler for %s/",name));
		}
	}
	else	free(eh);
	return(0);
}

