
#include "language.h"
#include "execute.h"
#include "../constable.h"
#include "../space.h"

int load_constant( struct register_s *r , u_int32_t typ, char * name )
{
	/* init register */
	r->flags=0;
	r->object=NULL;
	r->data=r->buf;
	r->attr= &(r->tmp_attr);
	r->attr->offset=0;
	r->attr->length=sizeof(u_int32_t);
	r->attr->type=MED_TYPE_UNSIGNED;
	*((u_int32_t*)(r->data))=0;
	r->attr->name[0]=0;
	if( typ==Tspace )
	{ struct space_s *t;
		if( (t=space_find(name))==NULL )
		{	runtime("Undefined space %s",name);
			return(0);
		}
		r->data= (char *)(t->my_vs->vs);
		r->attr->length=(MAX_VS_BITS/32)*4;
		r->attr->type=MED_TYPE_BITMAP|MED_TYPE_READ_ONLY;
		return(1);
	}
	runtime("Unknown type of constant!");
	return(0);
}

