
#ifndef _GENERIC_H
#define _GENERIC_H

#include "tree.h"
#include "event.h"
#include "object.h"

/* generic_set_subject - *cinfo ukazuje do stromu
 */
int generic_set_subject( struct object_s *o, u_int32_t *cinfo, void *user );

struct g_event_handler_s {
	struct event_handler_s h;
	struct event_handler_s *subhandler;
	u_int16_t	cinfo_offset;
	int		flags;
	struct tree_s	*root;
};
#define GFL_USE_VSE	0x01
#define GFL_FROM_OBJECT	0x02

int generic_hierarchy_handler(struct event_handler_s *h, struct event_context_s *c );

int generic_get_vs( vs_t *vs, int n, struct object_s *o, u_int32_t *cinfo );

int generic_init( char *name, struct event_handler_s *subhandler, struct event_type_s *event, struct class_s *class, int flags );

#endif /* _GENERIC_H */
